
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <signal.h>
#include <sys/time.h>
#include <sys/times.h>
#include <unistd.h>     /* _SC_CLK_TCK */

#include <string.h>
#include <error.h>
#include <locale.h>

static char const *input_file = NULL;
static char const *output_file = NULL;
static size_t input_blocksize = 512;
static size_t output_blocksize = 512;

int input_flags = 0;
int output_flags = 0;


static void
readopt (int argc, char **argv)
{
	int i;
	int bs=0;
	char *name;
	char *val;

	for (i = optind; i < argc; i++) {

		name = argv[i];
		val = strchr (name, '=');


		if (val == NULL) {
			error (0, 0, ("незарегистрированная опция %s"), name);
			exit (EXIT_FAILURE);
		}

		*val++ = '\0';

		if (strcmp(name,"if") == 0) {
			input_file = val;
			input_flags = 1;
		} else {
			if (strcmp(name,"of") == 0) {
				output_file = val;
				output_flags = 1;
			} else {
				if (strcmp(name,"ibs") == 0) {
					if (bs == 0) input_blocksize = atof(val);
				} else {
					if (strcmp(name,"obs") == 0) {
						if (bs == 0) output_blocksize = atof(val);
					} else {
						if (strcmp(name,"bs") == 0) {
							input_blocksize = atof(val);
							output_blocksize = atof(val);
							bs = 1;
						}
					}	
				}
			}
		}
	}
}



int main(int argc, char *argv[]) 
{
	
	setlocale (LC_ALL, "");
	FILE *in, *out;
	struct tms tms_stop,  tms_start;
	clock_t    real_stop, real_start, HZ;

	int  n;
	int col = 0;
	int col2 = 0;

	struct stat st;

	readopt(argc, argv); /* определение опций со знаком =*/

	char bufin[input_blocksize];
	char bufout[output_blocksize];

	if ((input_flags == 0) || (output_flags == 0)) {
		printf("ошибка\n");
		return EXIT_SUCCESS;
	}

	if ((in = fopen(input_file, "rb")) == NULL) {
		printf("Невозможно прочитать файл");
	}
	
	out = fopen(output_file, "w");

	HZ = sysconf(_SC_CLK_TCK);
	real_start = times(&tms_start);

	if (input_blocksize = output_blocksize)
		while ((n = read(fileno(in), bufin, input_blocksize)) > 0) {
			write(fileno(out), bufout, output_blocksize);
			col = col + 1;
			col2 = col;
		}

	real_stop = times(&tms_stop);

	fclose(out);
	fclose(in);

	stat(output_file, &st);
	printf("%u записей считано \n", col);
	printf("%u записей написано \n",col2);
	
	printf("скопировано: %d байт (%d B), %f c,  \n", st.st_size, st.st_size, (real_stop - real_start) / (double)HZ );

	return EXIT_SUCCESS;
}